#line 1 "C:/Arm_projects/Termometro_18b20/Termometro_18b20.c"
#line 27 "C:/Arm_projects/Termometro_18b20/Termometro_18b20.c"
sbit LCD_RS at GPIOA_ODR.B5;
sbit LCD_EN at GPIOA_ODR.B4;
sbit LCD_D4 at GPIOA_ODR.B0;
sbit LCD_D5 at GPIOA_ODR.B1;
sbit LCD_D6 at GPIOA_ODR.B2;
sbit LCD_D7 at GPIOA_ODR.B3;






const unsigned short TEMP_RESOLUTION = 12;


unsigned temp_lida;
#line 47 "C:/Arm_projects/Termometro_18b20/Termometro_18b20.c"
void Mostra_Temp_LCD(unsigned int temp_lida_salva) {
 const unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
 char temp_int,sign;
 unsigned int temp_fracao,a,b;


 if (temp_lida_salva & 0x8000) {

 sign = '-';
 temp_lida_salva = ~temp_lida_salva + 1;
 }
 else{
 sign = ' ';
 }


 temp_int = temp_lida_salva >> RES_SHIFT ;

 Lcd_Out(2,1,"Temp:           ");
 Lcd_Cmd(0xc5);

 if(sign==1) Lcd_Chr_CP('-'); else Lcd_Chr_CP(' ');

 a = temp_int/100 + '0';
 temp_int = temp_int % 100;

 if(a == '0')Lcd_Chr_CP(' ');
 else {
 Lcd_Chr_CP(a);
 }


 b = temp_int/10 + '0';
 temp_int= temp_int%10;
 if(b == '0' & a == '0')Lcd_Chr_CP(' ');
 else {
 Lcd_Chr_CP(b);
 }
 Lcd_Chr_CP(temp_int + '0');


 temp_fracao = temp_lida_salva << (4 - RES_SHIFT);
 temp_fracao &= 0x000F;
 temp_fracao *= 625;

 Lcd_Chr_Cp('.');

 Lcd_Chr_Cp(temp_fracao/1000 + '0');
 temp_fracao= temp_fracao%1000;

 Lcd_Chr_Cp(temp_fracao/100 + '0');
 temp_fracao= temp_fracao%100;
 Lcd_Chr_Cp(temp_fracao/10 + '0');

 Lcd_Chr_CP(' ');
 Lcd_Chr_CP(0xdf);
 Lcd_Chr_CP('C');
 delay_ms(400);
 }

 void Le_Temperatura_ds18b20(){

 Ow_Reset(&GPIOB_BASE, 12);
 Ow_Write(&GPIOB_BASE, 12, 0xCC);
 Ow_Write(&GPIOB_BASE, 12, 0x44);
 Delay_ms(750);

 Ow_Reset(&GPIOB_BASE, 12);
 Ow_Write(&GPIOB_BASE, 12, 0xCC);
 Ow_Write(&GPIOB_BASE, 12, 0xBE);

 temp_lida = Ow_Read(&GPIOB_BASE, 12);
 temp_lida = (Ow_Read(&GPIOB_BASE, 12) << 8) + temp_lida;
 }
#line 124 "C:/Arm_projects/Termometro_18b20/Termometro_18b20.c"
void main() {
 GPIO_Digital_Output(&GPIOA_BASE,  0x3f );

 Lcd_Init();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"Stm32_Termometer");
 Lcd_Out(2,1," by PicSource");
 delay_ms(2000);
#line 137 "C:/Arm_projects/Termometro_18b20/Termometro_18b20.c"
 for(;;) {
 Le_Temperatura_ds18b20();
 Mostra_Temp_LCD(temp_lida);
 }
}
